import pygame
from pygame.locals import *
import os
from player import Player


from resourceManager import ResourceManager
from gameScene import GameScene
class GameEngine:

   
   #############################################################################
   # INIT
   #############################################################################
   
	def __init__(self):      
		#Initialise pygame
		os.environ["SDL_VIDEO_CENTERED"] = "1"
		pygame.init()

		# Set up the display
		pygame.display.set_caption("Colour The Part")
		modes = pygame.display.list_modes(16)
		self.screen = pygame.display.set_mode(modes[0], FULLSCREEN, 16)
		#self.screen = pygame.display.set_mode((640, 480))

		self.clock = pygame.time.Clock()
		self.resourceManager = ResourceManager()
		# Fill background
		background = pygame.Surface(self.screen.get_size())
		background = background.convert()
		background.fill((75, 75, 75))

		# Display some text
		font = pygame.font.Font(None, 36)
		text = font.render("Colour The Part", 1, (255, 255, 255))
		textpos = text.get_rect()
		textpos.centerx = background.get_rect().centerx
		background.blit(text, textpos)

		# Blit everything to the screen
		self.screen.blit(background, (0, 0))
		pygame.display.flip()
		self.scene = GameScene(self)


	def loop(self):
		while True:
			self.events = pygame.event.get()
			self.clock.tick(60)
			self.screen.fill((0,0,0))
			self.scene.update()
			self.scene.render()
			pygame.display.flip()
			if self.__checkQuit():
				break

	def __checkQuit(self):
		for e in self.events:
			if e.type == pygame.QUIT:
				return True
			if e.type == pygame.KEYDOWN and e.key == pygame.K_ESCAPE:
				return True
		return False
		
	def __getEvents(self):
		self.events = pygame.event.get()
 
gE = GameEngine()
gE.loop()
pygame.quit()